#第四章、运算符
#1、算术运算符： + - * /（div） %（mod）

SELECT 100,100 + 0,100 - 0,100 + 50,100 - 50,
100 + 50 - 30,100 + 35.5,100 - 35.5
FROM DUAL;

#在SQL中，+没有连接的作用，就表示加法运算。
#此时，会将字符串转换为数值（隐式转换）
SELECT 100 + '1'	#在java语言中，结果是：1001
FROM DUAL;

SELECT 100 + 'a'	#此时将'a'看做0处理
FROM DUAL;

SELECT 100 + null	#null值参与运算，结果为null
FROM DUAL;

SELECT 100,100 * 1,100 / 1,100 * 1.0,100 / 1.0,100 / 2,
100 + 2 * 5 / 2,100 / 3,100 DIV 0	#分母如果为0，结果为null
FROM DUAL;

#取模运算：% mod
SELECT 12 % 3,12 % 5,12 MOD -5,-12 % 5,-12 % -5
FROM DUAL;
#结果的符号与被模数的符号一致

#练习：查询员工id为偶数的员工信息
SELECT employee_id,last_name,salary
FROM employees
WHERE employee_id % 2 = 0;

#2、比较运算符
#2.1	=	<=>	<>	!=	<	<=	>	>=

# = 的使用
SELECT 1 = 2,1 != 2,1 = '1',1 = 'a',0 = 'a'	#字符串存在隐式转换。如果转换数值不成功，则看做0
FROM DUAL;

SELECT 'a' = 'a','ab' = 'ab','a' = 'b'	#两边都是字符串的话，则按照ANSI的比较规则进行比较
FROM DUAL;

SELECT 1 = NULL,NULL = NULL	#只要有null参与判断，结果就为null
FROM DUAL;

SELECT last_name,salary
FROM employees
WHERE salary = 6000;
#WHERE commission_pct = NULL;#此时执行，不会有任何的结果

#	<=>：安全等于。记忆技巧：为NULL而生。
SELECT 1 <=> 2,1 <=> '1',1 <=> 'a',0 <=> 'a'	
FROM DUAL;

SELECT 1 <=> NULL,NULL <=> NULL
FROM DUAL;

#练习：查询员工表中commission_pct为null的数据有哪些
SELECT last_name,salary,commission_pct
FROM employees
WHERE commission_pct <=> NULL;

SELECT 3 <> 2,'4' <> NULL,'' != NULL,NULL != NULL
FROM DUAL;

#2.2
#(1)IS NULL \ IS NOT NULL \ ISNULL
#练习：查询员工表中commission_pct为null的数据有哪些
SELECT last_name,salary,commission_pct
FROM employees
WHERE commission_pct IS NULL;
#或
SELECT last_name,salary,commission_pct
FROM employees
WHERE ISNULL(commission_pct);

#练习：查询员工表中commission_pct不为null的数据有哪些
SELECT last_name,salary,commission_pct
FROM employees
WHERE commission_pct IS NOT NULL;
#或
SELECT last_name,salary,commission_pct
FROM employees
WHERE NOT commission_pct <=> NULL;

#(2) LEAST() \ GREATEST()

SELECT LEAST('g','b','t','m'),GREATEST('g','b','t','m')
FROM DUAL;

SELECT LEAST(first_name,last_name),LEAST(LENGTH(first_name),LENGTH(last_name))
FROM employees;

#(3) BETWEEN 条件1（下界） AND 条件2（上界）	（查询条件1和条件2范围内的数据，包含边界）
#查询工资在6000到8000的员工信息
SELECT employee_id,last_name,salary
FROM employees
#WHERE salary BETWEEN 6000 AND 8000;
WHERE salary >= 6000 && salary <= 8000;

#交换6000和8000的位置之后，查询不到数据
SELECT employee_id,last_name,salary
FROM employees
WHERE salary BETWEEN 8000 AND 6000;

#查询工资不在6000到8000的员工信息
SELECT employee_id,last_name,salary
FROM employees
#WHERE salary < 6000 OR salary > 8000;
WHERE salary NOT BETWEEN 6000 AND 8000;

#(4) IN(set)	\	NOT IN(set)
#练习1：查询部门为10,20,30的员工信息
SELECT last_name,salary,department_id
FROM employees
#WHERE department_id = 10 OR department_id = 20 OR department_id = 30;
WHERE department_id IN (10,20,30);

#练习2：查询工资不是6000,7000,8000的员工信息
SELECT last_name,salary,department_id
FROM employees
WHERE salary NOT IN (6000,7000,8000);

#（5）LIKE：模糊查询
# % ：代表不确定个数的字符（0个，1个，或多个）

#练习：查询last_name中包含字符'a'的员工信息
SELECT last_name,salary
FROM employees
WHERE last_name LIKE '%a%';

#练习：查询last_name中以字符'a'开头的员工信息
SELECT last_name,salary
FROM employees
WHERE last_name LIKE 'a%';

#练习：查询last_name中包含字符'a'且包含字符'e'的员工信息
#写法1
SELECT last_name,salary
FROM employees
WHERE last_name LIKE '%a%' AND last_name LIKE '%e%';

#写法2
SELECT last_name,salary
FROM employees
WHERE last_name LIKE '%a%e%' or last_name LIKE '%e%a%';

#	_ ：代表一个不确定的字符
#练习：查询第三个字符是'a'的员工信息
SELECT last_name,salary
FROM employees
WHERE last_name LIKE '__a%';

#练习：查询第二个字符是_且第三个字符是'a'的员工信息
#需要使用转义字符：\
SELECT last_name,salary
FROM employees
WHERE last_name LIKE '_\_a%';

#或者
SELECT last_name,salary
FROM employees
WHERE last_name LIKE '_$_a%' ESCAPE '$';

#（6）REGEXP \ RLIKE：正则表达式
SELECT 'shkstart' REGEXP '^s','shkstart' REGEXP 't$','shkstart' REGEXP 'hk'
FROM DUAL;

SELECT 'atguigu' REGEXP 'gu.gu','atguigu' REGEXP '[ab]'
FROM DUAL;

#3、逻辑运算符：OR	||	AND &&	NOT ! XOR

#OR	AND
SELECT last_name,salary,department_id
FROM employees
WHERE department_id = 50 AND salary > 6000;
#WHERE department_id = 10 OR department_id = 20;
#WHERE department_id = 10 AND department_id = 20;
WHERE department_id = 50 AND salary > 6000;

#NOT
SELECT last_name,salary,department_id
FROM employees
#WHERE salary NOT BETWEEN 6000 AND 8000;
#WHERE commission_pct IS NOT NULL;
WHERE NOT commission_pct <=> NULL;

#XOR：追求的“异”
SELECT last_name,salary,department_id
FROM employees
WHERE department_id = 50 XOR salary > 6000;

#注意：AND的优先级高于OR

#4、位运算符：&	| ^ ~ >>	<<

SELECT 12 & 5,12 | 5,12 ^ 5
FROM DUAL;

SELECT 10 & ~1 FROM DUAL;

#在一定范围内满足：每向左移动1位，相当于乘以2；每向右移动一位，相当于除以2
SELECT 4 << 1,8 >>1
FROM DUAL;

#拓展：使用正则表达式查询
#1、查询以特定字符或字符串开头的记录
#字符“^”匹配以特定字符或者字符串开头的文本。要查询的字符或者字符串必须放在“^”的后面。
#例：查询employees表中last_name字段值以字母“b”开头的所有信息。
SELECT *
FROM employees
WHERE last_name REGEXP '^b';

#2、查询以特定字符或字符串结尾的记录
#字符“$”匹配以特定字符或者字符串结尾的文本。要查询的字符或者字符串必须放在“$”的前面。
#例：查询employees表中last_name字段值以字母“y”结尾的所有信息。
SELECT *
FROM employees 
WHERE last_name REGEXP 'y$';

#3、用符号“.”来替代字符串中的任意一个字符
#例：查询employees表中last_name字段值包含字母“a”与“k”且两个字母之间只有一个字母的记录。
SELECT *
FROM employees
WHERE last_name REGEXP 'a.k';

#4、使用“*”和“+”来匹配多个字符
#星号“*”匹配前面的字符任意多次，包括0次。加号“+”匹配前面的字符至少一次。
#例1：查询employees表中last_name字段值以字母“b”开头且“b”后面出现字母“a”的记录。
SELECT *
FROM employees
WHERE last_name REGEXP '^ba*';

#例2：查询employees表中last_name字段值以字母“b”开头且“b”后面出现字母“a”至少一次的记录。
SELECT *
FROM employees
WHERE last_name REGEXP '^ba+';

#5、匹配指定字符串
#正则表达式可以匹配指定字符串，只要这个字符串在查询文本中即可，如要匹配多个字符串，多个字符串直接使用分隔符“|”隔开。
#例1：查询employees表中last_name字段值包含字符串“on”的记录。
SELECT *
FROM employees
WHERE last_name REGEXP 'on';

#例2：查询employees表中last_name字段值包含字符串“on”或者“no”的记录。
SELECT *
FROM employees
WHERE last_name REGEXP 'on|no';

SELECT *
FROM employees
WHERE last_name LIKE 'on';

#6、匹配指定字符中的任意一个
#方括号“[]”指定一个字符集合，只匹配其中任何一个字符，即为所查找的文本。
#例：查询employees表中last_name字段值包含字母“o”或者“t”的记录。
SELECT *
FROM employees
WHERE last_name REGEXP '[ot]';

#7、匹配指定字符以外的字符
#“[^字符集合]”匹配不在指定集合中的任何字符。
#例1：查询employees表中last_name字段值包含字母“a~e”以外的记录。
SELECT *
FROM employees
WHERE last_name REGEXP '[^a-e]';

#例2：查询employees表中last_name字段值包含字母“a~z”以外的记录。

SELECT *
FROM employees
WHERE last_name REGEXP '[^a-z]';

#8、使用{n,}或者{n,m}来指定字符串连续出现的次数
/*
	“字符串{n,}”表示至少匹配n次前面的字符串；“字符串{n,m}”表示匹配前面的字符串不少于n此，不多于m次。例如，“a{2,}”表示字母a练习出现至少2次，也可以大于2次；“a{2,4}”表示字符a连续出现最少2次，最多不能超过4次。
	
*/
#例1：查询employees表中last_name字段值出现字母“a”至少2次的记录。
SELECT *
FROM employees
WHERE last_name REGEXP 'a{2,}';

#例2：查询employees表中last_name字段值出现字母“a”最少1次、最多3次的记录。
SELECT *
FROM employees
WHERE last_name REGEXP 'a{1,3}';















